#ifndef GAME_H
#define GAME_H

#include <vga.h>
#include <vgagl.h>
#include <stdio.h>
#include <stdlib.h>

#define FRcolor 0xf
#define FRcolor2 0xd
#define BGcolor 1
#define w2 (w / 2)

// TCube

void beep();

class TGame
{
  int width, height, scores;
public:
   TGame (int, int);
  long gmcycle, lastmove;
  void addscore (int);
  void setscore (int);
  void update ();
  void moved ();
  char freshmove ();
  void play ();
};

class TCube
{
  int cl, hitcount;
  void draw (int);

public:
  char visible;
  int x, y, w, h;
    TCube ();
  int gethit ();
  void sethit (int);
  void show ();
  void hide ();
};

// TPlatform

class TPlatform
{
  int cl, xdelta, width, height;
  void draw (int);

public:
    TGame * gm;
  int x, y, w, h;
    TPlatform (int, int, TGame *);
  void move (int);
  void show ();
  void hide ();
};

// TGameball

class TBall
{
private:
  int rad, width, height;
  TPlatform *pl;
  void draw (int);
  char touchplato (TPlatform *);

public:
  float x, y, ax, ay, speed;
    TBall (int, int, TPlatform *);
  char touchcube (TCube *);
  void show ();
  void hide ();
  char move ();
};

#endif
